{㭤ᮢ .. 01.1998}
{ 㬥⮢: ᯨ᪨ TList}
UNIT TOOLS;

INTERFACE

  TYPE
    TListingType = array[1..1] of pointer; {ᯮ⥫ ⨯ 室}
    PListingType = ^TListingType;          { ࠡ ꥪ - ᯨ᪠}
    PList = ^TList;
    TList = object
      Capacity,Count,ExpSize : Integer;
      Store : PListingType;
      procedure InitList;
      function Items(Index : integer) : pointer;
      function IndexOf(Item : pointer) : integer;
      function GetCount : integer;
      procedure SetItems(Index : integer; Item : pointer);
      procedure Add(Item : pointer);
      procedure Remove(Item : pointer);
      procedure AtRemove(Index : integer);
      procedure SetExpSize(ESize : integer);
      procedure Clear;
      procedure Expand;
      procedure Pack;
    end;

IMPLEMENTATION

{   }
procedure TList.InitList;
begin
  ExpSize:=4; Capacity:=0; Count:=0; Store:=nil;
end;

function TList.Items;
var
  i : integer;
begin
  if Index>Count then begin
    Items:=nil; exit;
  end;
  Items:=Store^[Index];
end;

function TList.IndexOf; {頥   Item  ᯨ᪥}
var
  i : integer;
begin
  IndexOf:=0;
  for i:=1 to Count do
    if Store^[i]=Item then begin
      IndexOf:=i;
      break
    end;
end;

function TList.GetCount : integer;
begin
  GetCount:=Count
end;

procedure TList.SetItems; {ᨬ  㭪  ஬ Index  Item}
begin
  if Index>Count then exit;
  Store^[Index]:=Item;
end;

procedure TList.Add;
begin
  if Capacity=Count then Expand;
  inc(Count);
  Store^[Count]:=Item;
end;

procedure TList.SetExpSize;
begin
  if ExpSize>1 then ExpSize:=ESize
end;

procedure TList.Remove;
var i : integer;
begin
  for i:=1 to Count do
    if Store^[i]=Item then begin
      Store^[i]:=nil;
      break
    end;
end;

procedure TList.AtRemove; {塞  ᯨ᪠  ᮬ Index}
begin
  if Index>Count then exit;
  Store^[Index]:=nil;
end;

procedure TList.Clear;
begin
  if Store<>nil then freemem(Store,Capacity*4);
  Count:=0; Capacity:=0
end;

procedure TList.Expand;
var
  p : pointer;
  i : integer;
  NewStore : PListingType;
begin
  Capacity:=Capacity+ExpSize;
  if Capacity>16350 then begin
    Capacity:=Capacity-ExpSize;
    exit;
  end;
  getmem(NewStore,Capacity*4);
  for i:=1 to Count do
    NewStore^[i]:=Store^[i];
  if Store<>nil then freemem(Store,Count*4);
  Store:=NewStore
end;

procedure TList.Pack;
var
  NewStore : PListingType;
  p : pointer;
  i,j : integer;
begin
  getmem(NewStore,Count*4);
  j:=1;
  for i:=1 to Count do
    if Store^[i]<>nil then begin
      NewStore^[j]:=Store^[i]; inc(j);
    end;
  dec(j);
  if Store<>nil then freemem(Store,Capacity*4);
  Capacity:=Count; Count:=j;
  Store:=NewStore;
end;
{  }

BEGIN
END.